library IEEE;
use IEEE.STD_LOGIC_1164.all;

entity rising_edge_detector is
	 port(
		 CLEAR_L : in std_logic;
		 CLOCK_R : in std_logic;
		 SIGNAL_IN : in STD_LOGIC;		 
		 OUT_PULSE_RISING_H : out STD_LOGIC;
		 OUT_PULSE_RISING_FALLING_H : out STD_LOGIC;
		 OUT_PULSE_FALLING_H : out STD_LOGIC
		 );
end rising_edge_detector;

architecture rising_edge_detector of rising_edge_detector is
signal SIGNAL_IN_old1 :std_logic;
signal SIGNAL_IN_old2 :std_logic;
begin
process (CLOCK_R, CLEAR_L)
begin
	if CLEAR_L = '0' then
	OUT_PULSE_RISING_H <= '0';
	OUT_PULSE_FALLING_H <= '0';
	OUT_PULSE_RISING_FALLING_H <= '0';
	SIGNAL_IN_old1 <= '0';
	SIGNAL_IN_old2 <= '0';
	elsif
		(CLOCK_R'event and CLOCK_R= '1') then
		SIGNAL_IN_old1 <= SIGNAL_IN;	
		SIGNAL_IN_old2 <= SIGNAL_IN_old1;
		
		if SIGNAL_IN_old2 = '1' and SIGNAL_IN_old1 = '0' then
			OUT_PULSE_FALLING_H <= '1';
		else
			OUT_PULSE_FALLING_H <= '0';
		end if;
		
		if SIGNAL_IN_old2 = '0' and SIGNAL_IN_old1 = '1' then
			OUT_PULSE_RISING_H <= '1';
		else
			OUT_PULSE_RISING_H <= '0';
		end if;	
		
		if (SIGNAL_IN_old2 = '0' and SIGNAL_IN_old1 = '1') or (SIGNAL_IN_old2 = '1' and SIGNAL_IN_old1 = '0') then
			OUT_PULSE_RISING_FALLING_H <= '1';
		else
			OUT_PULSE_RISING_FALLING_H <= '0';
		end if;
	end if;
end process;
end rising_edge_detector;
